<template>
    <div class="container" v-if="!auth.jwt || !auth.username">
        Sorry, you don't seem to be logged in - please log in again.
    </div>
    <div class="container" v-if="auth.jwt && auth.username && userdata">
        <div class="item">
            <div class="item-span heading">User data</div>
            <div>Username</div>
            <input type="text" disabled :value="userdata.username"/>
            <div>E-mail address</div>
            <input type="text" disabled :value="userdata.email"/>
            <div>Institution</div>
            <input type="text" id="institution" :value="userdata.institution"/>
        </div>
        <div class="item">
            <div class="item-span heading">Change password</div>
            <div>Old password</div>
            <input type="password" v-model="old_pw" placeholder="Old password"/>
            <div>Type new password</div>
            <input type="password" v-model="pw1" placeholder="New password"/>
            <div>Repeat new password</div>
            <input type="password" v-model="pw2" placeholder="New password"/>
            <div class="item-span pw" :class="{'match' : pw1 === pw2}" v-if="pw1 && pw2">
                {{ pw1 === pw2 ? "The passwords match!" : "The passwords do not match." }}
            </div>
            <div class="item-span">
                <button :disabled="!pw1 || !pw2 || pw1 !== pw2" @click="changeMyPassword">Save</button>
            </div>
        </div>
        <div class="item">
            <div class="item-span heading">Verify account</div>
            <div class="item-span" v-if="userdata.verified === 'YES'">
                This user is <span style="color: var(--color-positive)">verified</span>! No further action needs to be taken.
            </div>
            <div class="item-span" v-if="userdata.verified !== 'YES'">
                This user is <span style="color: var(--color-negative)">not verified</span>! Please enter the code we sent you by mail.
                Until then, you will not be able to upload studies or view private studies, even if they were shared with your account.
            </div>
            <div v-if="userdata.verified !== 'YES'">Enter verification code</div>
            <input v-if="userdata.verified !== 'YES'" type="text" v-model="verification_code" placeholder="10-letter code"/>
            <div class="item-span" v-if="userdata.verified !== 'YES'">
                <button :disabled="!verification_code || verification_code.length != 10" @click="verifyMe">Verify</button>
            </div>
        </div>
        <div class="item no-border">
            <div class="item-span heading">Delete account</div>
            <div class="item-span">
                You can delete your account here. Note that deletion of your account will cause the following to happen:
                <ul>
                    <li>Deletion of all the studies you <b>uploaded</b> (studies that were shared with you will be unaffected). This includes deletion of all files you uploaded for the study.</li>
                    <li>All permissions associated with your account will automatically be revoked.</li>
                    <li>Your username and any study identifiers you used will be available to other users.</li>
                </ul>
            </div>
            <button @click="deleteMe">Delete my account</button>
        </div>
    </div>
</template>

<script setup lang="ts">
import { changePassword, deleteUser, logout, retrieveUserData, verifyUser, type UserData } from '@/modules/auth_module';
import { onMounted, ref } from 'vue';
import { useAuthStore } from '@/stores/auth';
import { useMessageStore, type Message } from '@/stores/message';
import router from '@/router';


const auth = useAuthStore();
const msg = useMessageStore();

onMounted(async () => {
    // Load user data on mounting this view
    const user_data: UserData = await retrieveUserData();
    if (user_data) userdata.value = user_data;
})

const verifyMe = async () => {
    if (!verification_code.value) {
        msg.add_message({msg: "Please enter the 10-character verification code!", status: 400})
    } else {
        const status: Message = await verifyUser(verification_code.value);
        msg.add_message(status);
        if (status.status === 200) {
            const user_data = await retrieveUserData();
            if (user_data) user_data.value = userdata;
            router.push('/')
        }         
    }
}

const changeMyPassword = async () => {
    if (!old_pw.value || !pw1.value || !pw2.value) {
        msg.add_message({msg: "Make sure to fill all three text fields!", status: 400});
        return;
    }
    const status: Message = await changePassword(old_pw.value, pw1.value)
    msg.add_message(status);
    if (status.status === 200) {
        logout();
        router.push('/');
    }
}

const deleteMe = async () => {
    const status: Message = await deleteUser();
    msg.add_message(status);
    if (status.status === 200) {
        logout();
        router.push('/');
    }
}


const userdata = ref<UserData|null>(null);
const pw1 = ref<string|null>(null);
const pw2 = ref<string|null>(null);
const old_pw = ref<string|null>(null);
const verification_code = ref<string|null>(null);
</script>

<style scoped>

.container {
    display: flex;
    justify-items: baseline;
    flex-direction: column;
    align-items: baseline;
    min-width: 40%;
    max-width: 80%;
    margin: 5.5rem auto;
}

.item {
    display: grid;
    justify-items: baseline;
    align-items: center;
    grid-template-columns: 0.3fr 0.7fr;
    width: 100%;
    margin: auto;
    row-gap: 1rem;
    padding: 1rem 0;
    border-bottom: var(--bd-default);
}

.no-border {
    border-bottom: none;
}

.item-span {
    grid-column: 1/3;
}

.heading {
    font-size: var(--fs-large);
    font-weight: 600;
}

.pw {
    font-size: var(--fs-default);
    color: var(--color-negative);
}

.match {
    color: var(--color-positive);
}

</style>